 -- Tests for linalg.cpkg
Package $apcocoa/ts/linalg


Define Initialize();
EndDefine;



-- standard
Define TestLinalg01()

TestRing::=QQ[x,y];

Using TestRing Do

  M := Mat([[ 1/2, 1/3, 2], [200, 3000, 1], [2, 5, 17], [1, 1, 1]]);
  Result:=LinAlg.REF(M, FALSE);
  Expected:=Mat([
  [1, 2/3, 4],
  [0, 1, -2397/8600],
  [0, 0, 1],
  [0, 0, 0]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");

EndUsing;

EndDefine;



--reduced row echolon form
Define TestLinalg02()

TestRing::=QQ[x,y];

Using TestRing Do

  M := Mat([[ 1/2, 1/3, 2], [200, 3000, 1], [2, 5, 17], [1, 1, 1]]);
  Result:=LinAlg.REF(M, TRUE);
  Expected:=Mat([
  [1, 0, 0],
  [0, 1, 0],
  [0, 0, 1],
  [0, 0, 0]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");

EndUsing;

EndDefine;


--REF over the ring Z/7Z
Define TestLinalg03()

TestRing::=QQ[x,y];

Using TestRing Do
  M := Mat([[ 9, 13, 2], [200, 3000, 1], [2, 5, 17], [1, 1, 1]]);
  Result:=LinAlg.REF(M,7, FALSE);
  Expected:=Mat([
  [1, 3, 1],
  [0, 1, 3],
  [0, 0, 1],
  [0, 0, 0]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");

EndUsing;

EndDefine;

--EF over the ring Z/2Z
Define TestLinalg04()

TestRing::=ZZ/(2)[x,y];

Using TestRing Do
  M := [
      [1, 1, 0, 1, 0],
      [0, 1, 1, 0, 1],
      [1, 0, 1, 0, 0], 
      [1, 1, 1, 0, 1]
     ];
  L1:=[1, 2, 3, 4]; 
  L2:=[0, 0, 1, 1]; 
  Result:=LinAlg.EF(M, L1, L2);
  Expected:=[ [[1, 1, 0, 1, 0], [0, 1, 1, 0, 1], [0, 0, 1, 1, 1], [0, 0, 0, 1, 1]], [1, 2, 4, 3], [0, 0, 1, 1]];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");

EndUsing;

EndDefine;
EndPackage;