-- Tests for linbox.cpkg
Package $apcocoa/ts/linbox


Define Initialize()
EndDefine;


--Charpoly over Z/19Z
Define TestLinbox01()

TestRing::=ZZ/(19)[x];

Using TestRing Do
  Result:=LinBox.CharPoly(BringIn(Mat([[1,2,3],[4,5,6],[7,8,9]])), x);
  Expected:=x^3 + 4x^2 + x;
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;



--Charpoly over Z
Define TestLinbox02()

TestRing::=ZZ[x];

Using TestRing Do
  Result:=LinBox.CharPoly(Mat([[1,2,3,5],[4,5,6,1],[7,8,9,-2],[2,4,6,7]]), x);
  Expected:=x^4 - 22x^3 + 85x^2 - 48x;
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;



-- Commented out since this type of computation is not yet available in
-- LinBox.
--
--Det over Q
--Define TestLinbox03()
--
--TestRing::=QQ[x];
--
--Using TestRing Do
--  Result:=LinBox.Det(Mat([[1,2],[0,5]]));
--  Expected:=5;
--  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
--EndUsing;
--
--EndDefine;



-- Commented out since this type of computation is not yet available in
-- LinBox.
--
--Det=0 over Q
--Define TestLinbox04()
--
--TestRing::=QQ[x];
--
--Using TestRing Do
--  Result:=LinBox.Det(Mat([[1,2],[2,4]]));
--  Expected:=0;
--  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
--EndUsing;
--
--EndDefine;



--Solve over finite field
Define TestLinbox05()

TestRing::=ZZ/(19)[x];

Using TestRing Do
  M := BringIn(Mat([[1,3,4], [0,2,1]]));
  B := BringIn(Mat([[1], [2]]));
  Result:=LinBox.Solve(M, B);  
  Expected:=Mat([
  [-2 % 19],
  [1 % 19],
  [0 % 19]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;



-- Commented out due to a bug in LinBox.
--
--Solve over Q without solution
--Define TestLinbox06()
--
--TestRing::=QQ[x];
--
--Using TestRing Do
--  M := Mat([ [1,3,4], [0,2,1], [1,3,4] ]);
--  B := Mat([ [1], [2], [0] ]);
--  Result:=LinBox.Solve(M, B);  
--  Expected:=Mat([[ ]]);
--  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
--EndUsing;
--
--EndDefine;



-- Commented out due to a bug in LinBox.
--
--Solve over Q with solution
--Define TestLinbox07()
--
--TestRing::=QQ[x];
--
--Using TestRing Do
--  M := Mat([ [1,3,4], [0,1,1], [1,3,3] ]);
--  B := Mat([ [1], [2], [0] ]);
--  Result:=LinBox.Solve(M, B);
--  Expected:=Mat([
--  [-6],
--  [1],
--  [1]]);
--  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
--EndUsing;
--
--EndDefine;



--Solve in ring Z with solution
Define TestLinbox08()

TestRing::=ZZ[x];

Using TestRing Do
  M := Mat([ [1,3,4], [0,1,1], [1,3,3] ]);
  B := Mat([ [1], [2], [0] ]);
  Result:=LinBox.Solve(M, B);
  Expected:=Mat([
  [-6],
  [1],
  [1]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;



--REF over Z/19Z
Define TestLinbox09()

TestRing::=QQ[x];

Using TestRing Do
  M := Mat([[1, 2, 3], [4, 5, 6], [7, 8, 9], [11, 12, 14]]);
  Result:=LinBox.REF(M, 19, FALSE);
  Expected:=Mat([
  [1, 2, 3],
  [0, 1, 2],
  [0, 0, 1],
  [0, 0, 0]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;



--RREF over finite field
Define TestLinbox10()

TestRing::=ZZ/(239)[x];

Using TestRing Do
  M := Mat([[1, 2, 3, 4], [5, 6, 7, 8], [7, 8, 9, 10]]);
  Result:= LinBox.REF(M, TRUE);
  Expected:=Mat([
  [1 % 239, 0 % 239, -1 % 239, -2 % 239],
  [0 % 239, 1 % 239, 2 % 239, 3 % 239],
  [0 % 239, 0 % 239, 0 % 239, 0 % 239]]);
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


EndPackage;